%Reads left/right images from disk. Calls SGM-functions and builds disparity map.
%Reads groundtruth and calculates error 

%clear all may clear also breakpoints...
clear VARIABLES; close all;

%Get images:
dataset = '000030';
path = ['imagepath',dataset,'\'];
scalefactor = 256;    %Correction of Groundtruth
tolerance = 3; %tau

I_raw_left = imread([path,'left.png']); 
I_raw_right = imread([path,'right.png']);
[hi, wi] = size(I_raw_left);

numberOfDisparities = 160;

doRectify = 0;      %Enable/Disable Rectification
doSharping = 0;     %Enable/Disable Sharpening Filter
doSpeckle = 0;      %Enable/Disable Speckle Filter

left = I_raw_left;
right = I_raw_right;

    left = im2uint8(left);
    %left = uint8(left);
    right = im2uint8(right);

%% Semi-Global Matching parameters. May be overwritten in subfunctions. 
params.preFilterCap = 63; % pre-processing with gaussian filter
params.SADWindowSize = 3; % block window size
params.P1 = 8*1*params.SADWindowSize^2;
params.P2 = 32*1*params.SADWindowSize^2;
params.minDisparity = 0;
params.numberOfDisparities = numberOfDisparities; % disparity range
params.uniquenessRatio = 10; % uniqueness filter
params.speckleWindowSize = 50; % speckle filter
params.speckleRange = 32;
params.disp12MaxDiff = 1; % left right consistenz filter
params.fullDP = false; % optimization in one or two passes.
params.CTlength = 11;
params.CTheight = 11;
params.MAX_COST = params.P2; 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disparity = rebuildDZSAD_refac(double(left), double(right), params);

% median filter
disparity = medfilt2(disparity, [3 3], 'symmetric');    %3x3 Median

figure; imshow(disparity,[]);

%%
gtAll = imread([path,'\eval\gtAll.png']);

all = disp_error(double(gtAll)/scalefactor, double(disparity),3);   %Kitti-Code: /256 nach double Konvertierung!
display(['All error: ', num2str(all*100), ' for correction factor ', num2str(fac)]);

noc = disp_error(double(gtNoc)/scalefactor, double(disparity),3);  %1.5 => D=160
display(['Noc error: ', num2str(noc*100), ' for correction factor ', num2str(fac)]);

display('All done');




