
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

library work;
use work.allconstantsPack.ALL;
use work.leftimagePack.ALL;
use work.rightimagePack.ALL;
 
ENTITY tb_censusLR IS
END tb_censusLR;
 
ARCHITECTURE behavior OF tb_censusLR IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT censusLR
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         enable : IN  std_logic;
         ready : OUT  std_logic;
         leftin : IN  unsigned(7 downto 0);
         rightin : IN  unsigned(7 downto 0);
         leftout : OUT  censusVectorType;
         rightout : OUT  censusVectorType
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal enable : std_logic := '0';
   signal leftin : unsigned(7 downto 0) := (others => '0');
   signal rightin : unsigned(7 downto 0) := (others => '0');

 	--Outputs
   signal ready : std_logic;
   signal leftout : censusVectorType;
   signal rightout : censusVectorType;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: censusLR PORT MAP (
          clk => clk,
          reset => reset,
          enable => enable,
          ready => ready,
          leftin => leftin,
          rightin => rightin,
          leftout => leftout,
          rightout => rightout
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      reset <= '1';	-- hold reset state for 100 ns.
    wait for clk_period * 2;
	reset <= '0';
		
	FOR y in 0 TO ImageHeight-1 LOOP	
		FOR x in 0 TO ImageWidth-1 LOOP
			leftin <= leftimage(y,x);
			rightin <= rightimage(y,x);
			wait for clk_period;
		END LOOP;
	END LOOP;
		
	wait for clk_period * 10;
		
	report "Done. All good!" severity failure;

end process;

END;
