LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

library work;
use work.constPack.ALL;
 
ENTITY tb_main IS
END tb_main;
 
ARCHITECTURE behavior OF tb_main IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT main
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         costs : IN  dVectorType;
         outval : OUT  unsigned(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal costs : dVectorType := (OTHERS => (others => '0'));

 	--Outputs
   signal outval : unsigned(7 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: main PORT MAP (
          clk => clk,
          reset => reset,
          costs => costs,
          outval => outval
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
stim_proc: process
BEGIN
	
	reset <= '1';
	wait for clk_period*2;
	reset <= '0';

	FOR x IN 1 TO 2500 LOOP
		FOR d in 1 TO 160 LOOP
			costs(d) <= to_unsigned(d+x,8);
		END LOOP;
		wait for clk_period;
	END LOOP;
      

    wait for clk_period * 10;
		
	report "Done. All good!" severity failure;
   end process;

END;
