LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE ieee.math_real.ALL;   -- for UNIFORM, TRUNC functions

library work;
use work.constPack.ALL;
 
ENTITY tbmultififo IS
END tbmultififo;
 
ARCHITECTURE behavior OF tbmultififo IS 
 
    COMPONENT multififowrapper
    PORT(
        clktop : in std_logic;
		resettop : in std_logic;
		waddrtop : in waddrType;
		wdatatop : in wdataType;
		--raddrtop : in raddrType;
		rdatatop : out rdataType
    );
    END COMPONENT;
    
   --Inputs
   signal clktop : std_logic := '0';
   signal resettop : std_logic := '0';
   signal waddrtop : waddrType := (OTHERS => (OTHERS => '0'));
   signal wdatatop : wdataType := (OTHERS => (OTHERS => '0'));
   --signal raddrtop : raddrType := (OTHERS => (OTHERS => '0'));

 	--Outputs
   signal rdatatop : rdataType;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: multififowrapper PORT MAP (
          clktop => clktop,
          resettop => resettop,
          waddrtop => waddrtop,
          wdatatop => wdatatop,
          --raddrtop => raddrtop,
          rdatatop => rdatatop
        );

   -- Clock process definitions
   clktop_process : PROCESS
   begin
		clktop <= '0';
		wait for clk_period/2;
		clktop <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
	stim_proc: process
		VARIABLE seed1, seed2: positive;               -- Seed values for random generator
		VARIABLE rand: real;                           -- Random real-number value in range 0 to 1.0
		VARIABLE int_rand: integer;                    -- Random integer value in range 0..4095
		VARIABLE stim: unsigned(6 DOWNTO 0);  -- Random 7-bit stimulus
	BEGIN
		
		resettop <= '1';
		wait for clk_period * 2;
		resettop <= '0';
		
		FOR x in 1 TO ImageWidth/2 LOOP
			
			FOR i IN 1 TO 20 LOOP
				UNIFORM(seed1, seed2, rand);                        -- generate random number
				int_rand := INTEGER(TRUNC(rand*128.0));             -- rescale to 0..128, find integer part
				stim := to_unsigned(int_rand, stim'LENGTH);  		-- convert to unsigned
				
				waddrtop(i) <= '0' & stim;
				wdatatop(i) <= "10" & to_unsigned(i,8);
			
			END LOOP;
		
			wait for clk_period;
		
		END LOOP;
		
		FOR x in (ImageWidth/2) + 1 TO ImageWidth LOOP
			
			FOR i IN 1 TO 20 LOOP
				waddrtop(i) <= to_unsigned(i,8);
				wdatatop(i) <= to_unsigned(i+10,10);
			
			END LOOP;
		
			wait for clk_period;
		
		END LOOP;
		
		wait;
		
	END PROCESS;
	
	readproc : PROCESS
	BEGIN
		wait for clk_period * 3;
		
		FOR y in 1 TO 2 LOOP
			FOR x in 1 TO ImageWidth LOOP
				FOR i IN 1 TO D LOOP
					--raddrtop(i) <= to_unsigned(i,8);
					
				END LOOP;
				wait for clk_period;
			END LOOP;
		END LOOP;
		
		report "Done" severity failure;
	END PROCESS;

END;
























